//
//  mdlTemplateItemSpec.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlTemplateItemSpec: Model, Content {
    static let schema = "templateItemSpec"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    
    @Parent(key: "templateCategoryId") var templatecategory: mdlTemplateCategory
    @OptionalParent(key: "itemId") var item: mdlItem?
    @OptionalParent(key: "specId") var spec: mdlSpec?
    
    @Field(key: "sortOrder") var sortorder: Int?
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         categoryid: Int,
         itemid: Int? = nil,
         specid: Int? = nil,
         sortorder: Int? = 0,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.$templatecategory.$id.value = categoryid
        if(itemid != nil){self.$item.$id.value = itemid}
        if(itemid != nil){self.$spec.$id.value = specid}
        self.sortorder = sortorder
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlTemplateItemSpec{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("templateItemSpec")
                .field("id", .int, .identifier(auto: true))
                .field("templateCategoryId", .int, .references("templateCategory", "id"))
                .field("itemId", .int, .references("item", "id"))
                .field("specId", .int, .references("spec", "id"))
                .field("sortOrder", .int)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("templateItemSpec").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlTemplateItemSpec>{
        
        let query = mdlTemplateItemSpec.query(on: req.db)
            .with(\.$templatecategory)
            .with(\.$item)
            .with(\.$spec)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

